Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/MetalTeapot.material
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/MetalTeapot.material	(revision 1720)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/scripts/MetalTeapot.material	(revision 1724)
@@ -1,6 +1,18 @@
+vertex_program DefaultVS hlsl
+{
+	source MetalTeapot.hlsl
+	entry_point DefaultVS
+	target vs_2_0 
+} 
+
+fragment_program Metal1BouncePS hlsl
+{
+	source MetalTeapot.hlsl
+	entry_point Metal1BouncePS
+	target ps_3_0
+} 
 
 material MetalTeapot
 { 
-
    technique 
    { 
@@ -13,6 +25,5 @@
 				update_interval		0
 				distance_calc false
-				face_angle_calc false
-				render		
+				face_angle_calc false					
 			}
 			RenderTechnique DistanceCubeMap
@@ -24,18 +35,17 @@
 		
 		 }
-		 vertex_program_ref GameTools/CubeMap/VertexPrograms/LocalizedVS
+		 vertex_program_ref DefaultVS
          {       
             param_named_auto worldViewProj worldviewproj_matrix 
     	    param_named_auto world world_matrix
-	    
+    	    param_named_auto worldview worldview_matrix
+    	    param_named_auto worldI inverse_world_matrix	    
          } 
-		 fragment_program_ref 	GameTools/CubeMap/FragmentPrograms/LocalizedMetalPS
+		 fragment_program_ref 	Metal1BouncePS
          { 
 			param_named_auto cameraPos camera_position
 			//param_named n float3 0.21 0.96 1.17
 			//param_named k float3 4.16 2.57 2.32
-			param_named F0 float3 0.95 0.63 0.54
-			param_named_auto lightPosition light_position 0 
-			
+			param_named F0 float3 0.95 0.63 0.54			
 		} 
 		
@@ -43,7 +53,5 @@
 		texture_unit
 		{
-			cubic_texture cubemap.jpg combinedUVW
-			tex_address_mode clamp
-			colour_op replace
+			
 		}
 
@@ -51,9 +59,152 @@
 		texture_unit
 		{
-			cubic_texture cubemap.jpg combinedUVW
-			tex_address_mode clamp
-			colour_op replace
+			
 		}
 	  }
     }
 }
+
+fragment_program NormalDistancePS hlsl
+{
+	source MetalTeapot.hlsl
+	entry_point NormalDistancePS
+	target ps_3_0
+} 
+
+material NormalDistanceCW
+{
+ technique 
+ { 
+  pass 
+  { 
+    cull_hardware clockwise
+    
+	vertex_program_ref DefaultVS
+    {       
+        param_named_auto worldViewProj worldviewproj_matrix 
+	    param_named_auto world world_matrix
+	    param_named_auto worldview worldview_matrix
+    	param_named_auto worldI inverse_world_matrix    
+    }
+    fragment_program_ref NormalDistancePS
+    { 
+				
+	} 
+  }
+ }
+}
+
+material NormalDistanceCCW
+{
+ technique 
+ { 
+  pass 
+  { 
+    cull_hardware anticlockwise
+	vertex_program_ref DefaultVS
+    {       
+        param_named_auto worldViewProj worldviewproj_matrix 
+	    param_named_auto world world_matrix
+	    param_named_auto worldview worldview_matrix
+    	param_named_auto worldI inverse_world_matrix    
+    }
+    fragment_program_ref NormalDistancePS
+    { 
+				
+	} 
+  }
+ }
+}
+
+fragment_program MetalMultipleBouncePS hlsl
+{
+	source MetalTeapot.hlsl
+	entry_point MetalMultipleBouncePS
+	target ps_3_0
+} 
+
+material MetalTeapotMultipleBounce
+{ 
+   technique 
+   { 
+      pass 
+      { 
+		IllumTechniques
+		{
+			RenderTechnique ColorCubeMap
+			{
+				update_interval		0
+				distance_calc false
+				face_angle_calc false					
+			}
+			RenderTechnique DistanceCubeMap
+			{
+				update_interval		0
+				distance_calc true false
+				face_angle_calc true false		
+			}
+			RenderTechnique ColorCubeMap
+			{
+				layer 1
+				texture_unit_id 2
+				update_interval		0
+				distance_calc true false
+				face_angle_calc true false
+				render_env false
+				render_self true
+				self_material NormalDistanceCCW
+			}
+			RenderTechnique ColorCubeMap
+			{
+				layer 2
+				texture_unit_id 3
+				update_interval		0
+				distance_calc true false
+				face_angle_calc true false
+				render_env false
+				render_self true
+				self_material NormalDistanceCW
+			}
+		
+		 }
+		 vertex_program_ref DefaultVS
+         {       
+            param_named_auto worldViewProj worldviewproj_matrix 
+    	    param_named_auto world world_matrix
+    	    param_named_auto worldview worldview_matrix
+    	    param_named_auto worldI inverse_world_matrix
+	    
+         } 
+		 fragment_program_ref 	MetalMultipleBouncePS
+         { 
+			param_named_auto cameraPos camera_position
+			//param_named n float3 0.21 0.96 1.17
+			//param_named k float3 4.16 2.57 2.32
+			param_named F0 float3 0.95 0.95 0.95			
+		} 
+		
+		//Cube map of environment
+		texture_unit
+		{
+			
+		}
+		//Cube map of environment distances
+		texture_unit
+		{
+			
+		}
+		
+		//Cube map of reflective object's normals and distances CCW
+		texture_unit
+		{
+			
+		}
+		
+		//Cube map of reflective object's normals and distances CW
+		texture_unit
+		{
+			
+		}
+	  }
+    }
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapot.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapot.hlsl	(revision 1720)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/MetalTeapot.hlsl	(revision 1724)
@@ -9,5 +9,5 @@
 float readDistanceCubeMap(samplerCUBE dcm, float3 coord)		
 {
-	float dist = texCUBE(dcm, float3(coord.xy, - coord.z)).r;
+	float dist = texCUBE(dcm, float3(coord.xy, - coord.z)).a;
 	return dist;
 }
@@ -15,8 +15,8 @@
 
 
-#define LIN_ITERATIONCOUNT 2
+#define LIN_ITERATIONCOUNT 5
 #define SECANT_ITERATIONCOUNT 2
-/*
-float3 Hit(float3 x, float3 R, samplerCUBE mp, float cameraDistance = 0)
+
+float Hit(float3 x, float3 R, samplerCUBE mp, out float3 newDir)
 {
 	R = normalize(R);
@@ -30,6 +30,7 @@
 	float dp, dl = 0, ppp, llp;
 	float lR = readDistanceCubeMap(mp, R);
-	float3 p = R;
-	
+	//float3 p = R;
+	float3 p = 0;
+		
 	float dt = 1.0 / LIN_ITERATIONCOUNT;
 	
@@ -38,27 +39,25 @@
 	while(t < 1.0 && !overshoot)
 	{
-		//if(!overshoot)
-		//{
-			dp = a * t / (1 - t);
-			p = x + R * dp;
-			float dist = readDistanceCubeMap(mp, p);
-			if(dist > 0)
-			{
-				ppp = length(p) / dist;
-				if(ppp < 1)
-				{
-					dl = dp;
-					llp = ppp;		
-					undershoot = true;		
-				}
-				else
-				{
-					if (undershoot) 
-					   overshoot = true;
-				}
-			}
-			else 
-				undershoot = false;
-		//}
+		dp = a * t / (1 - t);
+		p = x + R * dp;
+		float dist = readDistanceCubeMap(mp, p);
+		if(dist > 0)
+		{
+			ppp = length(p) / dist;
+			if(ppp < 1)
+			{
+				dl = dp;
+				llp = ppp;		
+				undershoot = true;		
+			}
+			else
+			{
+				if (undershoot) 
+				   overshoot = true;
+			}
+		}
+		else 
+			undershoot = false;
+	
 		t += dt;		
 	}
@@ -87,12 +86,13 @@
 	else
 		p = float3(0,0,0);
-	 
-	return p;
-}
-*/				
-
+	
+	newDir = p; 
+	return dp;
+}
+			
+/*
 float3 Hit( float3 x, float3 R, samplerCUBE mp )
 {
-	return R  + 0.00000000001 * x;
+	//return R  + 0.00000000001 * x;
 	float rl = readDistanceCubeMap( mp, R);				// |r|
 	
@@ -103,5 +103,5 @@
 
 	// iteration
-	for( int i = 0; i < 2; i++ )	// 2 !!!!!!!!!!!!!!!!!!!!!!!
+	for( int i = 0; i < SECANT_ITERATIONCOUNT; i++ )	
 	{
 		float llp = length( l ) / readDistanceCubeMap( mp, l);		// |l|/|l|
@@ -120,72 +120,37 @@
 	return l;												// computed hit point
 }
-
-void LocalizedVS(float4 position : POSITION,
-		out float3 wPos	: TEXCOORD1,				
-		float2 texCoord : TEXCOORD0,
-		out float2 otexCoord : TEXCOORD0,
-		float3 normal   : NORMAL,
-		out float3 mNormal  : TEXCOORD2,
-		out float4 hPos : POSITION,		
-		uniform float4x4 worldViewProj,
-		uniform float4x4 world)
-{
- 
-  hPos = mul(worldViewProj, position);
-  wPos = mul(world, position).xyz;  
-  mNormal = normal;
-  otexCoord = texCoord;
-}
-
-//////////////
-//Localized reflection
-//////////////
-void LocalizedPS(  float2 texCoord : TEXCOORD0, 
-		float3 wPos	: TEXCOORD1,	
-		float3 mNormal  : TEXCOORD2,
-		uniform float3 cameraPos,
-		uniform samplerCUBE CubeMap : register(s0),
-		uniform samplerCUBE DistanceMap : register(s1),
-		uniform float3 lastCenter,
-		uniform float3 lightPosition,		
-		out float4 Color :COLOR0)
-{
-	
-	Color = float4(1,1,1,1);
-	
-	mNormal = normalize(mNormal);
-	float3 RR, TT;	
-	float3 mPos = wPos - lastCenter;
-	float3 V = normalize(wPos - cameraPos);
-	float3 R = /*normalize*/(reflect( V, mNormal));
-	
-	float3 T = refract(V, mNormal, 0.9);
-		
-	RR = R;	TT = T;
-	//RR += 0.000001 * lastCenter.x;
-	RR = Hit(mPos, R, DistanceMap);
-	TT = Hit(mPos, T, DistanceMap);
-	
-	float4 reflectcolor = readCubeMap(CubeMap, RR );		
-	float4 refractcolor = readCubeMap(CubeMap, TT );		
-	
-	float cos_theta = -dot(V, mNormal);
-	float sFresnel = 0.1;
-	float F = (sFresnel + pow(1-cos_theta, 5.0f) * (1-sFresnel));
-    
-    float3 L = normalize(lightPosition - wPos);
-	float3 H = normalize(L+V);
-	float4 lighting = lit(dot(mNormal, L),dot(mNormal, H), 30);
-	Color = (F * reflectcolor + (1-F) * refractcolor) + lighting.z;	
-}
-
-
+*/
+
+struct VertOut
+{
+	float3 wPos	: TEXCOORD1;
+	float3 cPos	: TEXCOORD3;
+	float2 texCoord : TEXCOORD0;
+	float3 mNormal  : TEXCOORD2;
+	float4 hPos : POSITION;			
+};
+
+VertOut DefaultVS(float4 position : POSITION,						
+				float2 texCoord : TEXCOORD0,
+				float3 normal   : NORMAL,
+				uniform float4x4 worldViewProj,
+				uniform float4x4 world,
+				uniform float4x4 worldview,
+				uniform float4x4 worldI	)
+{
+  VertOut OUT;
+  OUT.hPos = mul(worldViewProj, position);
+  OUT.wPos = mul(world, position).xyz;  
+  OUT.cPos = mul(worldview, position).xyz;  
+  OUT.mNormal = mul(normal, worldI);  
+  //OUT.mNormal = normal;
+  OUT.texCoord = texCoord;
+  return OUT;
+}
 
 //////////////
 //Metal
 //////////////
-void LocalizedMetalPS(  float2 texCoord : TEXCOORD0, 
-		float3 wPos	: TEXCOORD1,	
-		float3 mNormal  : TEXCOORD2,
+void Metal1BouncePS(  VertOut IN,
 		uniform float3 cameraPos,
 		uniform samplerCUBE CubeMap : register(s0),
@@ -198,22 +163,19 @@
 	Color = float4(1,1,1,1);
 	
-	mNormal = normalize(mNormal);
+	IN.mNormal = normalize(IN.mNormal);
 	float3 newTexCoord;	
-	float3 mPos = wPos - lastCenter;
-	float3 V  = (wPos - cameraPos);
+	float3 mPos = IN.wPos - lastCenter;
+	float3 V  = (IN.wPos - cameraPos);
 	float cameraDistace = length(V);
 	V = normalize(V);
-	float3 R = normalize(reflect( V, mNormal));
-		
-	newTexCoord = R;	
-	
-	newTexCoord = Hit(mPos, R, DistanceMap);
-	/*if(dot(newTexCoord,newTexCoord) == 0) 
-		Color = float4(0.5,0.5,0.5,1);
-	else*/
-		Color = readCubeMap(CubeMap, newTexCoord );	
-	
-	float ctheta_in = dot(mNormal,R);
-	float ctheta_out = dot(mNormal,-V);
+	float3 R = normalize(reflect( V, IN.mNormal));
+		
+	newTexCoord = R + 0.00000001 * lastCenter.x;	
+	//newTexCoord = R;	
+	//Hit(mPos, R, DistanceMap, newTexCoord);
+	Color = readCubeMap(CubeMap, newTexCoord );	
+	
+	float ctheta_in = dot(IN.mNormal,R);
+	float ctheta_out = dot(IN.mNormal,-V);
 
 	float3 F = 0;
@@ -229,13 +191,12 @@
 	Color = Color * float4(F,1);	
 }
-//////////////
-//PhotonMap
-//////////////
-/*void PhotonMapPS(  float2 texCoord : TEXCOORD0, 
-		float3 wPos	: TEXCOORD1,	
-		float3 mNormal  : TEXCOORD2,
+
+
+void MetalMultipleBouncePS(  VertOut IN,
 		uniform float3 cameraPos,
-		uniform samplerCUBE UVMap : register(s0),
+		uniform samplerCUBE CubeMap : register(s0),
 		uniform samplerCUBE DistanceMap : register(s1),
+		uniform samplerCUBE NormDistMap1 : register(s2),
+		uniform samplerCUBE NormDistMap2 : register(s3),
 		uniform float3 lastCenter,
 		out float4 Color :COLOR0)
@@ -244,186 +205,76 @@
 	Color = float4(1,1,1,1);
 	
-	mNormal = normalize(mNormal);
+	IN.mNormal = normalize(IN.mNormal);
 	float3 newTexCoord;	
-	float3 mPos = wPos - lastCenter;
-	float3 V = normalize(wPos - cameraPos);
-	float3 R = normalize(reflect( V, mNormal));
-		
-	newTexCoord = R;	
-	
-	newTexCoord = Hit(mPos, R, DistanceMap);
-	
-	Color = readCubeMap(UVMap, newTexCoord );
-	//Color = float4(1,0,0,1);		
-}*/
-
-float4 PhotonMapCausticPS(  float2 texCoord : TEXCOORD0, 
-		float3 wPos	: TEXCOORD1,	
-		float3 mNormal  : TEXCOORD2,
-		uniform float3 cameraPos,
-		uniform samplerCUBE DistanceMap : register(s0),
-		uniform float3 lastCenter):COLOR0
-{
-	
-	float4 Color = float4(1,1,1,1);
-	
-	mNormal = normalize(mNormal);
-	float3 newTexCoord;	
-	float3 mPos = wPos - lastCenter;
-	float3 V = normalize(wPos - cameraPos);
-		
-	float3 R = refract(V, mNormal, 0.85);		
-	//float3 R = V;	
-	newTexCoord = R;	
-		
-	newTexCoord = Hit(mPos, R, DistanceMap);
-		
-	Color = float4(newTexCoord, 1);
-	
-	//Color = 0.0001 * Color +  float4(0,0,1,1);
-	//Color += 0.0001 * lastCenter.x;
-	if(dot(V,mNormal)>0)
-	{
-		Color = float4(1,0,0,0);		
-	}		
-	return Color;
-}
-
-
-
-/////////////////////
-///// Diffuse
-///////////////////
-
-float4 GetContibution(float3 L, float3 pos, float3 N, float3 V, samplerCUBE SmallEnvMapSampler, samplerCUBE DistanceEnvMapSampler)	// Phong-Blinn
-// L: a hossza lényeges (az egységkocka faláig ér)
-{
-    REDUCED_CUBEMAP_SIZE = 4;
-    
-	float kd = 0.3;	// 0.3
-	float ks = 0;	// 0.5
-	float shininess = 10;
-	
-	float l = length(L);
-	L = normalize(L);
-
-	//dw
-	float dw = 4 / (REDUCED_CUBEMAP_SIZE*REDUCED_CUBEMAP_SIZE*l*l*l + 4/3.1416f);
-	//Lin
-	float4 Lin = readCubeMap(SmallEnvMapSampler, L);
-	//r
-	float doy = readDistanceCubeMap(DistanceEnvMapSampler, L);
-	float dxy = length(L * doy - pos);	
-
-	//dws
-	float dws = (doy*doy * dw) / (dxy*dxy*(1 - dw/3.1416f) + doy*doy*dw/3.1416f);	// localization:
-	//float dws = dw;
-	
-	//L = L * doy - pos;	// L: x->y, az objektumtól induljon, ne a középpontból
-	L = normalize(L);
-	float3 H = normalize(L + V);	// felezõvektor
-
-	float a = kd * max(dot(N,L),0) + 
-			  ks * pow(max(dot(N,H),0), shininess); // diffuse + specular
-
-	// 1.: eddigi
-	//return Lin * a * dws;
-	
-	float ctheta_in = dot(N,L);
-	float ctheta_out = dot(N,V);	
-	
-	return Lin * a * dws;		
-}
-
-void DiffuseVS( float4 position : POSITION,
-                float3 normal : NORMAL,
-                float2 Tex : TEXCOORD0,
-                uniform float4x4 worldViewProj,
-				uniform float4x4 world,
-				//uniform float3 lastCenter,	//LI//
-				out float4 hposition : POSITION,
-                out float2 oTex : TEXCOORD0,
-                out float3 Normal : TEXCOORD1,
-                out float3 pos : TEXCOORD2 )
-{
-	pos = /*lastCenter + 0.01 * */mul( world, position ).xyz;
-	Normal = normal;
-    oTex = Tex;    
-    hposition = mul( worldViewProj, position );
-}
-
-
-float4 DiffusePS( float2 Tex : TEXCOORD0,
-           float3 N : TEXCOORD1,
-           float3 pos : TEXCOORD2,
-           uniform float3 cameraPos,
-           uniform float3 lastCenter,	//LI//
-           uniform samplerCUBE SmallEnvMapSampler : register(s0),
-           uniform samplerCUBE DistanceEnvMapSampler : register(s1)
-            ) : COLOR0
-{
-    REDUCED_CUBEMAP_SIZE = 4;
-	
-    //V = /*-*/normalize( V );
-    float3 V = normalize(pos - cameraPos);	// 
-    N = normalize( N ); 
-	float3 R = reflect(V, N);
-    pos -= lastCenter;
-
-	
-    //return float4(N,1);
-    //return float4(V,1);
-    //return float4(R,1);
-		
-	//return readCubeMap(SmallEnvMapSampler,R);
-	
-    //pos.xy += float2(1.0/LIGHT_TEXTURE_SIZE, -1.0/LIGHT_TEXTURE_SIZE);	// eltolás a pixel/texel középpontba
-    // x, y = -1..1
-    // z = 1
-    
-    float4 intens = 0;
-    /*
-	intens += GetContibution( R, pos, N, V, SmallEnvMapSampler);
-	intens = readCubeMap(SmallEnvMapSampler, R);
-	return intens;*/
-	
-	for (int x = 0; x < REDUCED_CUBEMAP_SIZE; x++)			// az envmap minden texelére
-	 for (int y = 0; y < REDUCED_CUBEMAP_SIZE; y++)
-	//int x = 0;		// az envmap 1 texelére
-	//int y = 0; 
-	//if (x==LIGHT_TEXTURE_SIZE/2 && y==LIGHT_TEXTURE_SIZE/2)
-	 {
-		// intenzitás kiolvasása az adott texelbõl 
-		
-		float2 p, tpos; 
-	    tpos.x = x/(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    tpos.y = y/(float)REDUCED_CUBEMAP_SIZE;	// 0..1
-	    tpos.xy += float2(0.5/REDUCED_CUBEMAP_SIZE, 0.5/REDUCED_CUBEMAP_SIZE);	// az adott texel középpont uv koordinátái
-	    
-	    p.x = tpos.x; 
-	    p.y = 1-tpos.y;
-	    p.xy = 2*p.xy - 1;	// -1..1	// az adott texel középpont pozíciója
-	    
-	    float3 L;
-	   
-		L = float3(p.x, p.y, 1);
-		intens += GetContibution( L, pos, N, V, SmallEnvMapSampler, DistanceEnvMapSampler);
-		
-		L = float3(p.x, p.y, -1);
-		intens += GetContibution( L, pos, N, V, SmallEnvMapSampler, DistanceEnvMapSampler);
-		
-		L = float3(p.x, 1, p.y);
-		intens += GetContibution( L, pos, N, V, SmallEnvMapSampler, DistanceEnvMapSampler);
-		
-		L = float3(p.x, -1, p.y);
-		intens += GetContibution( L, pos, N, V, SmallEnvMapSampler, DistanceEnvMapSampler);
-		
-		L = float3(1, p.x, p.y);
-		intens += GetContibution( L, pos, N, V, SmallEnvMapSampler, DistanceEnvMapSampler);
-		
-		L = float3(-1, p.x, p.y);
-		intens += GetContibution( L, pos, N, V, SmallEnvMapSampler, DistanceEnvMapSampler);
-	}
-
-	return intens;
-}
+	float3 mPos = IN.wPos - lastCenter;
+	float3 V  = (IN.wPos - cameraPos);
+	float cameraDistace = length(V);
+	V = normalize(V);
+	float3 R = normalize(reflect( V, IN.mNormal));
+		
+	newTexCoord = R;
+	
+	//Color = readCubeMap(NormDistMap1, mPos );
+	//return;
+	
+	float3 newDir1;
+	float d1 = Hit(mPos, R, NormDistMap1, newDir1);
+	float3 normal1 = readCubeMap(NormDistMap1, newDir1);
+	float3 newDir2;
+	float d2 = Hit(mPos, R, NormDistMap2, newDir2);
+	float3 normal2 = readCubeMap(NormDistMap2, newDir2);
+		
+	if( dot(newDir2,newDir2) == 0.0 && dot(newDir1,newDir1) == 0.0 )
+	{
+		Hit(mPos, R, DistanceMap, newTexCoord);	
+		Color = readCubeMap(CubeMap, newTexCoord );			
+	}
+	else
+	{
+		float3 newV;
+		float3 newR;
+		float3 newN = normal1;
+		float3 dir = newDir1;
+		float d = d1;
+		float3 newX;
+		//closer hit
+		if(d1 > d2)
+		{
+			dir = newDir2;
+			d = d2;
+			newN = normal2;
+		}
+		newV = R;
+		newX = mPos + R * d;
+		newR = normalize(reflect( newV, newN));
+		
+		Hit(newX, newR, DistanceMap, newTexCoord);	
+		Color = readCubeMap(CubeMap, newTexCoord );		
+	}
+	 
+	//Color = float4(newDir2,1);
+	
+	float ctheta_in = dot(IN.mNormal,R);
+	float ctheta_out = dot(IN.mNormal,-V);
+
+	float3 F = 0;
+	
+	// F,P,G számítása
+	if ( ctheta_in > 0 && ctheta_out > 0 )
+	{
+		float3 H = normalize(R - V);	// felezõvektor
+		float cbeta  = dot(H,R);		
+		F = F0 + (1-F0)*pow(1-cbeta,5);
+	}	
+	
+	Color = Color * float4(F,1);	
+}
+
+float4 NormalDistancePS( VertOut IN):COLOR
+{
+ 
+ float4 Color = float4(0, 0, 0, 0);
+ //return Color;
+ Color = float4(normalize(IN.mNormal), length(IN.cPos));
+ return Color;
+}
Index: GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Localized_EnvMap.hlsl
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Localized_EnvMap.hlsl	(revision 1720)
+++ GTP/trunk/App/Demos/Illum/Ogre/Media/materials/programs/GameTools_Localized_EnvMap.hlsl	(revision 1724)
@@ -46,4 +46,5 @@
 float3 Hit(float3 x, float3 R, samplerCUBE mp, float cameraDistance = 0)
 {
+	return R + 0.000000001 *x;
 	R = normalize(R);
 	
@@ -197,10 +198,12 @@
 		out float4 hPos : POSITION,		
 		uniform float4x4 worldViewProj,
-		uniform float4x4 world)
+		uniform float4x4 world,
+		uniform float4x4 worldI
+		)
 {
  
   hPos = mul(worldViewProj, position);
   wPos = mul(world, position).xyz;  
-  mNormal = normal;
+  mNormal = mul(normal, worldI);  
   otexCoord = texCoord;
 }
Index: GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h
===================================================================
--- GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 1720)
+++ GTP/trunk/App/Demos/Illum/Ogre/src/ReflectionTest/include/ReflectionTest.h	(revision 1724)
@@ -35,7 +35,8 @@
 protected:
 	unsigned long framecount;
+	SceneNode* objectNode;
 	
 public:
-    RaytraceDemoListener(RenderWindow* window, Camera* maincam)
+    RaytraceDemoListener(RenderWindow* window, Camera* maincam, SceneNode* objectNode)
         :ExampleFrameListener(window, maincam) 
 				 
@@ -43,8 +44,138 @@
 		this->mMoveSpeed = 2.0;
 		framecount = 0;		
+		this->objectNode = objectNode;
     }
 	bool processUnbufferedKeyInput(const FrameEvent& evt)
     {
-		return ExampleFrameListener::processUnbufferedKeyInput(evt);
+		static float objmove = 0.01;
+		if (mInputDevice->isKeyDown(KC_UP))
+        {
+			objectNode->translate(0,0,objmove);
+        }
+		if (mInputDevice->isKeyDown(KC_MULTIPLY))
+        {
+			//objectNode->scale(1.1,1.1,1.1);
+			objectNode->rotate(Vector3(0,0,1), Degree(10));
+			mTimeUntilNextToggle = 1;
+        }
+		if (mInputDevice->isKeyDown(KC_DIVIDE))
+        {
+			//objectNode->scale(1.0/1.1,1.0/1.1,1.0/1.1);
+			objectNode->rotate(Vector3(1,0,0), Degree(10));
+			mTimeUntilNextToggle = 1;
+        }
+		if (mInputDevice->isKeyDown(KC_ADD))
+        {
+			objectNode->rotate(Vector3(0,1,0), Degree(10));
+        }
+		if (mInputDevice->isKeyDown(KC_HOME))
+        {
+			objectNode->translate(0,objmove,0);
+        }
+		if (mInputDevice->isKeyDown(KC_END))
+        {
+			objectNode->translate(0,-objmove,0);
+        }
+		if (mInputDevice->isKeyDown(KC_DOWN))
+        {
+			objectNode->translate(0,0,-objmove);
+        }
+		if (mInputDevice->isKeyDown(KC_RIGHT))
+        {
+			objectNode->translate(-objmove,0,0);
+        }
+		if (mInputDevice->isKeyDown(KC_LEFT))
+        {
+			objectNode->translate(objmove,0,0);
+        }
+
+		if (mInputDevice->isKeyDown(KC_A))
+        {
+            // Move camera left
+            mTranslateVector.x = -mMoveScale;
+        }
+
+        if (mInputDevice->isKeyDown(KC_D))
+        {
+            // Move camera RIGHT
+            mTranslateVector.x = mMoveScale;
+        }
+
+        /* Move camera forward by keypress. */
+        if ( mInputDevice->isKeyDown(KC_W) )
+        {
+            mTranslateVector.z = -mMoveScale;
+        }
+		
+        /* Move camera backward by keypress. */
+        if (mInputDevice->isKeyDown(KC_S) )
+        {
+            mTranslateVector.z = mMoveScale;
+        }
+
+        if (mInputDevice->isKeyDown(KC_PGUP))
+        {
+            // Move camera up
+            mTranslateVector.y = mMoveScale;
+        }
+
+        if (mInputDevice->isKeyDown(KC_PGDOWN))
+        {
+            // Move camera down
+            mTranslateVector.y = -mMoveScale;
+        }       
+
+        if( mInputDevice->isKeyDown( KC_ESCAPE) )
+        {            
+            return false;
+        }
+
+		// see if switching is on, and you want to toggle 
+        if (mInputTypeSwitchingOn && mInputDevice->isKeyDown(KC_M) && mTimeUntilNextToggle <= 0)
+        {
+			switchMouseMode();
+            mTimeUntilNextToggle = 1;
+        }
+
+        if (mInputTypeSwitchingOn && mInputDevice->isKeyDown(KC_K) && mTimeUntilNextToggle <= 0)
+        {
+			// must be going from immediate keyboard to buffered keyboard
+			switchKeyMode();
+            mTimeUntilNextToggle = 1;
+        }
+        if (mInputDevice->isKeyDown(KC_F) && mTimeUntilNextToggle <= 0)
+        {
+            mStatsOn = !mStatsOn;
+            showDebugOverlay(mStatsOn);
+
+            mTimeUntilNextToggle = 1;
+        }
+       
+        if (mInputDevice->isKeyDown(KC_SYSRQ) && mTimeUntilNextToggle <= 0)
+        {
+			char tmp[20];
+			sprintf(tmp, "screenshot_%d.png", ++mNumScreenShots);
+            mWindow->writeContentsToFile(tmp);
+            mTimeUntilNextToggle = 0.5;
+			mWindow->setDebugText(String("Wrote ") + tmp);
+        }
+		
+		static bool displayCameraDetails = false;
+        if (mInputDevice->isKeyDown(KC_P) && mTimeUntilNextToggle <= 0)
+        {
+            displayCameraDetails = !displayCameraDetails;
+            mTimeUntilNextToggle = 0.5;
+            if (!displayCameraDetails)
+                mWindow->setDebugText("");
+        }
+        if (displayCameraDetails)
+        {
+            // Print camera details
+            mWindow->setDebugText("P: " + StringConverter::toString(mCamera->getDerivedPosition()) + " " + 
+                "O: " + StringConverter::toString(mCamera->getDerivedOrientation()));
+        }
+
+        // Return true to continue rendering
+        return true;
 	}
     bool frameStarted(const FrameEvent& evt)
@@ -91,9 +222,9 @@
 
      	Entity* object = mSceneMgr->createEntity("object", "teapot.mesh");
-		object->setMaterialName("EnvMetals/Gold");
+		object->setMaterialName("MetalTeapotMultipleBounce");
 		objectNode = rootNode->createChildSceneNode();
 		objectNode->attachObject(object);
 		objectNode->scale(0.5,0.5,0.5);
-		objectNode->rotate(Vector3(0,1,0),Radian(Math::PI));
+		//objectNode->scale(0.005,0.005,0.005);
 		objectNode->setPosition(0,1.2,0);
 		objectNode->_updateBounds();
@@ -146,5 +277,5 @@
     {
 		// This is where we instantiate our own frame listener
-		mFrameListener= new RaytraceDemoListener(mWindow, mCamera);
+		mFrameListener= new RaytraceDemoListener(mWindow, mCamera, objectNode);
 		mFrameListener->setPriority(1);
 		OgreIlluminationManager::getSingleton().setPriority(2);
